--[[                               ################################################
                                   #                                              #                                                  
                                   #             SCRIPT PRODUZIDO POR:            #
                                   #                   DaNiLiN                    #
                                   #                                              #
                                   ################################################
--]]
--============================================================================================================================--

--[[                               
                                   ################################################
                                   #                SISTEMA MECANICO              #                                                                
                                   ################################################
--]]

function Repair_Vehicle ( Car )
local cx, cy, cz = getElementPosition ( Car )
local px, py, pz = getElementPosition ( source )
local distance	= getDistanceBetweenPoints3D ( cx, cy, cz, px, py, pz )
local Kit_Repair = getElementData ( source, "DNL:KitRepair" ) or 0
local exps = tonumber(getElementData(source, "Exp")) or 0
   if ( distance <= 2.5 ) then
     if getElementData ( source, "E:Mecanico", true) then 
       if Kit_Repair <= 0 then exports.Scripts_Dxmessages:outputDx(source, "Você Não tem Kit Reparo", "error") return end
        if getElementData(source, "Reparando", true) then exports.Scripts_Dxmessages:outputDx(source, "Você já está reparando algum veiculo", "error") return end	
		if getPedOccupiedVehicle(source) then exports.Scripts_Dxmessages:outputDx(source, "Saia do veiculo para efetuar o Reparo.", "error") return end	
			setPedAnimation( source, "CAMERA", "piccrch_take", 3000, true, false, true, false)
	         triggerClientEvent (source, "DNL:RepararStart", source)
	         setElementData ( source, "DNL:KitRepair", Kit_Repair - 1)
	         setElementData(source, "Exp", exps + 10)	
		
		setTimer(function()
	         fixVehicle ( Car )
		end, 3000, 1)
     end
   end
end
addEvent ( "DNL:Reparar", true )
addEventHandler ( "DNL:Reparar", root, Repair_Vehicle)


function ComandoMecanico ( source )
local Name = getPlayerName(source)
if getElementData ( source, "Chamado:Mecanico", true ) then exports.Scripts_Dxmessages:outputDx(source, "Você já pediu um Mecânico, Agora Aguarde!", "warning") return end
exports.Scripts_Dxmessages:outputDx(source, "Os Mecanicos Foram Avisados, Aguarde no Local!", "warning")
setElementData ( source, "Chamado:Mecanico", true )
setTimer ( function() removeElementData ( source, "Chamado:Mecanico" ) end, 60000, 1 )

local Jogadores = getElementsByType("player")
for _,Jogad in ipairs(Jogadores) do

  if getElementData ( source, "E:Mecanico", true) then 
     exports.Scripts_Dxmessages:outputDx(Jogad, "O Jogador "..Name.." Chamou Por um Mecanico! Digite /Localizar Nick", "warning")
    end
  end
end
addCommandHandler("mecanico", ComandoMecanico )

--[[                               
                                   ################################################
                                   #             Ignora daqui pra baixo           #                                                                
                                   ################################################
--]]

function DesligarAndLigar ( playerSource )
   if math.floor ( getElementHealth( source ) + 0.5 ) > 350 then 
    setVehicleDamageProof( source, false ) -- Não Quebrado
    else 
    setVehicleEngineState( source, false ) -- Quebrado
    exports.Scripts_Dxmessages:outputDx(playerSource, "Esse Veiculo Está Quebrado, Chame Por um Mecanico digitando /Mecanicos", "warning")
    end 
end 
addEventHandler ( "onVehicleEnter", root, DesligarAndLigar )


addEventHandler("onVehicleDamage", getRootElement(),function(loss)
	if getElementType ( source ) == "vehicle" then
		if not isVehicleDamageProof(source) then
			local HP = getElementHealth(source)-loss		
			if HP <= 350 then 
				HP = 350 
				setElementHealth(source,350)
				setVehicleEngineState(source,false)
				setVehicleDamageProof(source,true)
				if isVehicleBlown(source) then
					fixVehicle(source)	
					setElementHealth(source,350)
					setVehicleDamageProof(source,true)
				end 
			end
		end	
	end	
end)
