--[[
/\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\/
                                   <><><><><><><><><><><><><><><><><><><><><><><><>
                                   #                                              #
                                   #              Script Criado Por               #
                                   #                 DanilinMTA                   #
                                   #                                              #
                                   <><><><><><><><><><><><><><><><><><><><><><><><>

/\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\//\\/
--]]	

Preco_Kit = 500 -- Mude Preço do kit aqui!
LimiteReparoMec = 5 -- Mude Limite de Kit Aqui!


--[[
         ><><><><><><><><><><><><><><><><><><><><
         ><           Infos Trabalho           ><
         ><><><><><><><><><><><><><><><><><><><><
--]]

function Info (source)
  if getElementData ( source, "E:Mecanico", true) then 
	outputChatBox("#00ff00=====================================================", source, 255, 255, 255, true)  
	outputChatBox("#00FF00", source, 255, 255, 255, true)  
	outputChatBox("#00ff00/qg - #ffffffPara Marcar seu Local de Trabalho no Mapa.", source, 255, 255, 255, true)  
	outputChatBox("#00FF00", source, 255, 255, 255, true)  
	outputChatBox("#00ff00Trabalhar - #ffffffClique no veiculo Para Repara-lo.", source, 255, 255, 255, true)  
	outputChatBox("#00FF00", source, 255, 255, 255, true)  
	outputChatBox("#00ff00=====================================================", source, 255, 255, 255, true) 
  end
end
addCommandHandler ( "infos", Info )

function Quartel_Emprego ( source )
  if getElementData ( source, "E:Mecanico", true) then 
	if isElementVisibleTo ( Blip_Emprego, source ) then
	   setElementVisibleTo ( Blip_Emprego, source, false )
	   outputChatBox ( "#00ff00✘ #ffffffINFO #00ff00✘➺ #ffffffSeu Local de Trabalho foi Desmarcado do Mapa!", source, 255,255,255, true)
	else
	   setElementVisibleTo ( Blip_Emprego, source, true )
	   outputChatBox ( "#00ff00✘ #ffffffINFO #00ff00✘➺ #ffffffSeu Local de Trabalho foi Marcado no Mapa!", source, 255,255,255, true)
	end
  end	
end    
addCommandHandler ( "qg", Quartel_Emprego )


--[[
         ><><><><><><><><><><><><><><><><><><><><
         ><              Trabalho              ><
         ><><><><><><><><><><><><><><><><><><><><
--]]

AbrirPainelMecanico = createMarker(2650.31250, -2021.82507, 14.17663 -1, "cylinder", 1.2, 0, 255, 0, 50)
setElementVisibleTo ( AbrirPainelMecanico, root, true )

Blip_Emprego = createBlipAttachedTo( AbrirPainelMecanico, 42 )
setElementVisibleTo ( Blip_Emprego, root, false )

function BlipOFF ()
	setElementVisibleTo ( Blip_Emprego, source, false )	
end
addEvent("AG:BlipsOFF",true)
addEventHandler("AG:BlipsOFF",root, BlipOFF)

function OpenPainelMed(source)
  if getElementData ( source, "E:Mecanico", true) then 
   if isElementWithinMarker(source, AbrirPainelMecanico) then
	  triggerClientEvent(source,"MEC:Painel",source)	 
	  setElementVisibleTo ( Blip_Emprego, source, false )
   end
  else
	exports.Scripts_Dxmessages:outputDx(source, "Apenas Mecânicos podem entrar aqui!", "warning")
  end
end
addEventHandler( "onMarkerHit", AbrirPainelMecanico, OpenPainelMed )



function SetSkin ()
setElementModel (source, 50)
end
addEvent("DNL:SetSkinMec", true)
addEventHandler("DNL:SetSkinMec", getRootElement(), SetSkin)

VehMecanico = {}

function SetCarMecanico ()
if isPedInVehicle(source) then return end
if VehMecanico[source] and isElement( VehMecanico[source] ) then destroyElement ( VehMecanico[source] )
VehMecanico[source] = nil
end
x,y,z = getElementPosition(source)
VehMecanico[source] = createVehicle(525, 2645.17065, -2030.34265, 13.54688)
setElementRotation(VehMecanico[source], 0,0,0)
setVehicleLocked(VehMecanico[source],false)
setVehicleColor( VehMecanico[source], 255, 255, 255 )
setVehiclePlateText ( VehMecanico[source], "Danilin MTA" )
warpPedIntoVehicle ( source, VehMecanico[source] )
end
addEvent("DNL:CarMecânico",true)
addEventHandler("DNL:CarMecânico",root, SetCarMecanico)




Destroy={}

function ExitCar (source)
  if (VehMecanico[source]) and isElement(VehMecanico[source]) then	
  
	Destroy[source] = setTimer ( function()
      destroyElement (VehMecanico[source])
	end, 1200000, 1 )
	
   end
end
addEventHandler ("onVehicleExit", root, ExitCar)

function EnterCar (source)
  if (VehMecanico[source]) and isElement(VehMecanico[source]) then	
	if isTimer(Destroy[source]) then
		killTimer(Destroy[source])
	end
  end
end
addEventHandler ("onVehicleEnter", root, EnterCar)

function SaiuServer ( quitType )
  if isElement(VehMecanico[source]) then
    if not isVehicleOccupied(VehMecanico[source]) then
     destroyElement (VehMecanico[source])
    end
  end
end
addEventHandler ( "onPlayerQuit", getRootElement(), SaiuServer )


function isVehicleOccupied(vehicle)
    assert(isElement(vehicle) and getElementType(vehicle) == "vehicle", "Bad argument @ isVehicleOccupied [expected vehicle, got " .. tostring(vehicle) .. "]")
    local _, occupant = next(getVehicleOccupants(vehicle))
    return occupant and true, occupant
end